#ifndef ConnectionManager_h
#define ConnectionManager_h

#include <string>
#include <vector>

#ifdef __APPLE__
#   include "AppleBluetoothManager.h"
#else
#include "WinBluetoothManager.h"
#endif

enum ConnectionType
{
    LOCAL, BT, TCP
};

class ConnectionManager
{
    public:
    
        ConnectionManager(std::string deviceName, ConnectionType connectionType);
        ~ConnectionManager();
    
        bool connect();
        void disconnect();
    
        std::vector<std::string> sendMessageAndWaitResponse(std::string message, bool dontSplit = false);
        void messageReceived(std::string message);
    
        std::string deviceName;
        ConnectionType connectionType;
    
#ifdef __APPLE__
		AppleBluetoothManager * manager;
#else
		WindowsBluetoothManager * manager;
		//TODO other platforms
#endif

    private:

        
};

ConnectionManager*  newTCPConnection();

#endif /* ConnectionManager_h */
